// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Pose.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _Pose_H_
#define _Pose_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>
#include <stdbool.h>
#include "Quaternion.h"
#include "Point.h"

/*!
 * @brief This struct represents the structure Pose defined by the user in the IDL file.
 * @ingroup POSE
 */
typedef struct Pose
{
    Point position;
    Quaternion orientation;
} Pose;

struct ucdrBuffer;

bool Pose_serialize_topic(struct ucdrBuffer* writer, const Pose* topic);
bool Pose_deserialize_topic(struct ucdrBuffer* reader, Pose* topic);
uint32_t Pose_size_of_topic(const Pose* topic, uint32_t size);


#ifdef __cplusplus
}
#endif

#endif // _Pose_H_